﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Controls.Menus;

namespace WpfApp1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            _xdt.Loaded += _xdt_Loaded;
        }

        private void _xdt_Loaded(object sender, RoutedEventArgs args)
        {
            var rootItems = new List<MyTreeItem>();
            for (int a = 0; a < 5; a++)
            {
                var nodeA = new MyTreeItem($"a:{a}");
                rootItems.Add(nodeA);
                for (int b = 0; b < 5; b++)
                {
                    var nodeB = new MyTreeItem($"a:{a}-b:{b}");
                    nodeA.Children.Add(nodeB);
                    for (int c = 0; c < 5; c++)
                    {
                        var nodeC = new MyTreeItem($"a:{a}-b:{b}-c:{c}");
                        nodeB.Children.Add(nodeC);
                        for (int d = 0; d < 5; d++)
                        {
                            var nodeD = new MyTreeItem($"a:{a}-b:{b}-c:{c}-d:{d}");
                            nodeC.Children.Add(nodeD);
                            for (int e = 0; e < 30; e++)
                            {
                                var nodeE = new MyTreeItem($"a:{a}-b:{b}-c:{c}-d:{d}-e:{e}");
                                nodeD.Children.Add(nodeE);
                            }
                        }
                    }
                }
            }

            _xdt.ItemsSource = rootItems;
        }

        public class MyTreeItem
        {
            public string Name { get; }

            public MyTreeItem(string name)
            {
                Name = name;
            }

            public List<MyTreeItem> Children { get; } = new List<MyTreeItem>();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            TraverseTree(_xdt.Nodes);
        }

        private static void TraverseTree(XamDataTreeNodesCollection nodes)
        {
            foreach (XamDataTreeNode node in nodes)
            {
                if (node.HasChildren)
                {
                    TraverseTree(node.Nodes);
                }
            }
        }
    }
}
